## mongodb 3.4.7

=== debian/changelog ===
mongodb (1:3.4.7-1ubuntu1) bionic; urgency=medium

  * d/p/major-minor-sysmacros: fix FTBFS following glibc update. Closes:
    #882643.

 -- Robie Basak <robie.basak@ubuntu.com>  Fri, 15 Dec 2017 17:36:26 +0000

mongodb (1:3.4.7-1build1) bionic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Oct 2017 17:20:37 +0000

mongodb (1:3.4.7-1) experimental; urgency=medium

  * New upstream bugfix release; see
    https://docs.mongodb.com/manual/release-notes/3.4/
  * Refresh disable-hw-crc32-on-arm64-s390x.patch
  * Bump Standards to 4.0.1; no changes needed
  * Bump compat to 10
  * New patch to fix FTBFS with GCC 7 (Closes: #853556)

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Sun, 13 Aug 2017 23:25:53 -0400

mongodb (1:3.4.1-3) experimental; urgency=medium

  * s390x: do not attempt to build the asm CRC32 implementation; fixes FTBFS
  * d/copyright: adjust src/third_party/* paths

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Fri, 23 Dec 2016 23:40:35 +0200

=== debian/control ===
Source: mongodb
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian MongoDB Maintainers <pkg-mongodb-maintainers@lists.alioth.debian.org>
Uploaders: Laszlo Boszormenyi (GCS) <gcs@debian.org>,
           Jérémy Lal <kapouer@melix.org>,
           Apollon Oikonomopoulos <apoikos@debian.org>
Build-Depends:
 debhelper (>= 10),
 libboost-date-time-dev,
 libboost-dev (>> 1.50),
 libboost-filesystem-dev,
 libboost-iostreams-dev,
 libboost-program-options-dev,
 libboost-thread-dev,
 libboost-regex-dev,
 libgoogle-perftools-dev [linux-amd64 linux-arm64 linux-ppc64el],
 libyaml-cpp-dev,
 libpcap-dev,
 libpcre3-dev,
 libreadline-dev,
 libsnappy-dev,
 libstemmer-dev,
 libssl1.0-dev,
 zlib1g-dev,
 python-pymongo,
 python-subprocess32,
 python-yaml,
 python,
 scons,
 tzdata,
 valgrind
Standards-Version: 4.0.1
Vcs-Git: https://anonscm.debian.org/git/pkg-mongodb/mongodb.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-mongodb/mongodb.git/
Homepage: https://www.mongodb.org

Package: mongodb
Architecture: amd64 arm64 ppc64el s390x
Depends: mongodb-server (>= 1:2.4.1-2), ${misc:Depends}, ${shlibs:Depends}
Description: object/document-oriented database (metapackage)
 MongoDB is a high-performance, open source, schema-free
 document-oriented data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features:
 .
    * Collection oriented storage - easy storage of object-style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This is a convenience metapackage that depends on all the mongodb parts:
 the server, the clients and the development files (headers and library).

Package: mongodb-server
Architecture: amd64 arm64 ppc64el s390x
Depends:
 mongodb-clients,
 adduser, 
 lsb-base (>= 3.0-6),
 ${misc:Depends},
 ${shlibs:Depends}
Replaces:
 mongodb (<= 1:1.4.2-2)
Description: object/document-oriented database (server package)
 MongoDB is a high-performance, open source, schema-free
 document-oriented data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features:
 .
    * Collection oriented storage - easy storage of object-style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This package contains the server itself  (mongod) and the sharding
 server/load-balancer (mongos).

Package: mongodb-clients
Architecture: amd64 arm64 ppc64el s390x
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends: mongo-tools
Replaces:
 mongodb (<= 1:1.4.2-2)
Description: object/document-oriented database (client apps)
 MongoDB is a high-performance, open source, schema-free
 document-oriented data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features:
 .
    * Collection oriented storage - easy storage of object-style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This package contains the standard administrative shell (mongo) and other
 utilities for administration or analysis of performance of the server.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Use gcc and g++ by default, but allow setting them from the environment
CC ?= gcc
CXX ?= g++

DEB_SCONS_OPTIONS :=
ifneq (,$(filter debug,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_OPTIONS := --d=DEBUGBUILD
endif

ifeq (,$(filter nodbgsym,$(DEB_BUILD_OPTIONS)))
       DEB_SCONS_OPTIONS += --nostrip
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
       PROCS=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
       DEB_SCONS_OPTIONS += -j$(PROCS)
endif

COMMON_OPTIONS = --use-system-tcmalloc --use-system-pcre \
		 --use-system-boost --use-system-snappy \
		 --use-system-zlib --use-system-valgrind \
		 --use-system-stemmer --use-system-yaml \
		 --ssl $(DEB_SCONS_OPTIONS) \
		 CC=$(CC) CXX=$(CXX)

gperftools_archs = amd64 ppc64el arm64
ifneq (,$(filter $(DEB_HOST_ARCH), $(gperftools_archs)))
COMMON_OPTIONS += --allocator=tcmalloc
else
COMMON_OPTIONS += --allocator=system
endif

# Wiredtiger does not build on 32-bit systems
ifeq (32, $(DEB_HOST_ARCH_BITS))
COMMON_OPTIONS += --wiredtiger=off
endif

override_dh_auto_clean:
	scons --keep-going --clean $(COMMON_OPTIONS) .
	find $(CURDIR)/ -name "*.pyc" -delete
	rm -rf $(CURDIR)/debian/tmp-test/
	rm -rf $(CURDIR)/.scons/
	rm -rf $(CURDIR)/build/

override_dh_auto_build:
	scons $(COMMON_OPTIONS) core tools

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	scons $(COMMON_OPTIONS) dbtest unittests
	python ./buildscripts/resmoke.py --dbpathPrefix="$(CURDIR)/debian/tmp-test" --suites=dbtest,unittests
.PHONY: override_dh_auto_test
endif

override_dh_auto_install:
	scons $(COMMON_OPTIONS) --prefix=$(CURDIR)/debian/tmp/usr install

override_dh_systemd_enable:
	dh_systemd_enable -pmongodb-server --name=mongodb

override_dh_installinit:
	dh_installinit -pmongodb-server --name=mongodb


override_dh_install:
	dh_install --list-missing

%:
	dh $@ --parallel

.PHONY: override_dh_auto_clean override_dh_auto_build \
	override_dh_auto_install override_dh_installinit \
	override_dh_systemd_enable override_dh_install

## mongodb 3.4.14

=== debian/changelog ===
mongodb (1:3.4.14-3ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Rework Breaks+Replaces for the bionic version, this can be dropped
      once bionic is out.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 10 Apr 2018 12:38:47 +0200

mongodb (1:3.4.14-3) unstable; urgency=medium

  * d/control: correct mongodb-server-core Breaks/Replaces (Closes: #893893)

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Fri, 23 Mar 2018 17:59:10 +0200

mongodb (1:3.4.14-2) unstable; urgency=medium

  * Fix altivec-related FTBFS on ppc64el

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Fri, 23 Mar 2018 14:52:30 +0200

mongodb (1:3.4.14-1) unstable; urgency=medium

  * New upstream stable release (Closes: #882643)
  * Drop/Refresh patches
    + Drop patches for architectures no longer built
      - 0001-Create-kfreebsd-like-linux-in-most-respects.patch
      - 0002-kfreebsd-has-dev-urandom.patch
      - 0012-support-gnu.patch
      - use-mmapv1-on-i386
    + Drop obsolete/merged patches
      - fix-boost-1.62-build.patch
      - fix-gcc-6-ftbfs.patch
      - use-std::regex.patch
      - fix-build-with-openssl-1.1.patch
      - fix-mozjs-38-segfaults.patch
      - arm64-48bit-va-compat.patch
      - scons-3.0-compat.patch
    + Refresh fix-ftbfs-with-gcc-7.patch
  * Ship the mongod and mongos binaries in mongodb-server-core. This allows
    the use of special-purpose Mongo instances without the need for a
    system-wide setup (Closes: #893621). Thanks to Robie Basak!
  * Upload to unstable, merging all experimental development history
  * Switch Vcs-* URLs to salsa.d.o
  * Bump Standards-Version to 4.1.3; no changes needed
  * Bump dh compat to 11
    + Use dh_missing instead of dh_install --list-missing
    + Use dh_installsystemd instead of dh_systemd_enable
  * d/rules: do not pass --parallel to dh, this is now done by default
  * d/watch: switch URL to https://
  * d/mongodb.conf: rename oplog to diaglog (Closes: #892955)

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Thu, 22 Mar 2018 14:18:12 +0200

mongodb (1:3.4.7-1ubuntu4) bionic; urgency=medium

  * d/p/disable-broken-ppc64el-altivec: disable buggy AltiVec optimisations on
    ppc64el for now to fix FTBFS until upstream has a proper fix (LP:
    #1758116). This may result in a performance regression on ppc64el only,
    which is tracked at LP 1758118.

 -- Robie Basak <robie.basak@ubuntu.com>  Thu, 22 Mar 2018 12:49:32 +0000

mongodb (1:3.4.7-1ubuntu3) bionic; urgency=medium

  * Break out mongodb-server-core to provide binaries only as a separate
    package (LP: #1756432). This allows users (such as Juju) to use the mongodb
    binaries only for use in non-system-wide databases without conflict with
    what a user on the same system may be doing. This follows the same pattern
    already established with MySQL and MariaDB packaging.

 -- Robie Basak <robie.basak@ubuntu.com>  Tue, 13 Feb 2018 11:35:01 +0000

mongodb (1:3.4.7-1ubuntu2) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 06 Feb 2018 17:54:53 +0000

mongodb (1:3.2.17-1) unstable; urgency=medium

  * New upstream stable release; see
    https://docs.mongodb.com/manual/release-notes/3.2/ for notable changes
    since 3.2.16.
  * Backport upstream fix to allow building with SCons 3.0.
  * Remove obsolete upstart script.
  * Bump Standards to 4.1.1; no changes needed.

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Sun, 08 Oct 2017 10:41:09 +0300

mongodb (1:3.2.16-1) unstable; urgency=medium

  * New upstream stable release; see
    https://docs.mongodb.com/manual/release-notes/3.2/ for notable changes
    since 3.2.11.
  * Fix mongod NULL pointer dereference by disabling GCC optimizations for
    mozjs (Closes: #876755)
  * mongodb.service: raise resource limits.
    Thanks to Joshua Powers <josh.powers@canonical.com> (Closes: #857969)
  * mongodb.service: start after network.target (Closes: #864407)
  * mongodb-server.postinst: only create the mongodb user when it doesn't
    exist (Closes: #858903)
  * Switch to OpenSSL 1.1 (Closes: #859232)
    + Patch upstream source to revert breakage introduced in 3.2.16.
    + Backport OpenSSL 1.1 support for ASIO.

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Thu, 28 Sep 2017 01:13:37 +0300

mongodb (1:3.2.11-4) unstable; urgency=medium

  * Bump Standards to 4.1.0; no changes needed
  * Fix segfault/FTBFS on ARM64 with 48-bit virtual addresses (Closes: #871906)

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Mon, 25 Sep 2017 23:50:52 +0300

mongodb (1:3.2.11-3) unstable; urgency=medium

  * d/changelog: restore the 2.6.12-3 entry (Closes: #848305)
  * Fix FTBFS with GCC 7 (Closes: #853556)
  * Bump compat to 10
    + B-D on debhelper (>= 10)
    + Remove --with=systemd from dh invocations
  * Bump Standards to 4.0.1; no changes needed

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Fri, 11 Aug 2017 14:37:37 -0400

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: mongodb
 Section: database
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian MongoDB Maintainers <pkg-mongodb-maintainers@lists.alioth.debian.org>
+Maintainer: Debian MongoDB Maintainers <pkg-mongodb-maintainers@lists.alioth.debian.org>
 Uploaders: Laszlo Boszormenyi (GCS) <gcs@debian.org>,
            Jérémy Lal <kapouer@melix.org>,
            Apollon Oikonomopoulos <apoikos@debian.org>
 Build-Depends:
- debhelper (>= 10),
+ debhelper (>= 11~),
  libboost-date-time-dev,
  libboost-dev (>> 1.50),
  libboost-filesystem-dev,
@@ -22,7 +21,7 @@
  libreadline-dev,
  libsnappy-dev,
  libstemmer-dev,
- libssl1.0-dev,
+ libssl-dev,
  zlib1g-dev,
  python-pymongo,
  python-subprocess32,
@@ -31,9 +30,9 @@
  scons,
  tzdata,
  valgrind
-Standards-Version: 4.0.1
-Vcs-Git: https://anonscm.debian.org/git/pkg-mongodb/mongodb.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-mongodb/mongodb.git/
+Standards-Version: 4.1.3
+Vcs-Git: https://salsa.debian.org/mongodb-team/mongodb.git
+Vcs-Browser: https://salsa.debian.org/mongodb-team/mongodb
 Homepage: https://www.mongodb.org
 
 Package: mongodb
@@ -59,16 +58,15 @@
  the server, the clients and the development files (headers and library).
 
 Package: mongodb-server
-Architecture: amd64 arm64 ppc64el s390x
+Architecture: all
 Depends:
  mongodb-clients,
+ mongodb-server-core (>= ${source:Version}),
+ mongodb-server-core (<< ${source:Version}.1~),
  adduser, 
  lsb-base (>= 3.0-6),
  ${misc:Depends},
- ${shlibs:Depends}
-Replaces:
- mongodb (<= 1:1.4.2-2)
-Description: object/document-oriented database (server package)
+Description: object/document-oriented database (managed server package)
  MongoDB is a high-performance, open source, schema-free
  document-oriented data store that's easy to deploy, manage
  and use. It's network accessible, written in C++ and offers
@@ -84,8 +82,33 @@
  High performance, scalability, and reasonable depth of
  functionality are the goals for the project.
  .
- This package contains the server itself  (mongod) and the sharding
- server/load-balancer (mongos).
+ This package installs MongoDB as a system service.
+
+Package: mongodb-server-core
+Architecture: amd64 arm64 ppc64el s390x
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Breaks:
+ mongodb-server (<< 1:3.4.7-1ubuntu2)
+Replaces:
+ mongodb-server (<< 1:3.4.7-1ubuntu2)
+Description: object/document-oriented database (server binaries package)
+ MongoDB is a high-performance, open source, schema-free
+ document-oriented data store that's easy to deploy, manage
+ and use. It's network accessible, written in C++ and offers
+ the following features:
+ .
+    * Collection oriented storage - easy storage of object-style data
+    * Full index support, including on inner objects
+    * Query profiling
+    * Replication and fail-over support
+    * Efficient storage of binary data including large objects (e.g. videos)
+    * Auto-sharding for cloud-level scalability
+ .
+ High performance, scalability, and reasonable depth of
+ functionality are the goals for the project.
+ .
+ This package contains the database server (mongod) and sharding
+ server/load-balancer (mongos) binaries.
 
 Package: mongodb-clients
 Architecture: amd64 arm64 ppc64el s390x

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.sig/,uversionmangle=s/(\d)-(rc\d+)$/$1~$2/ \
	https://www.mongodb.org/dl/src/ .*/mongodb-src-r(3\.4\..*)\.tar\.gz

## mongodb 3.4.18

=== SConstruct ===
# -*- mode: python; -*-
import atexit
import copy
import datetime
import errno
import json
import os
import re
import shlex
import shutil
import stat
import sys
import textwrap
import uuid
from buildscripts import utils
from buildscripts import moduleconfig

import SCons

from mongo_scons_utils import (
    default_buildinfo_environment_data,
    default_variant_dir_generator,
    get_toolchain_ver,
)

import libdeps

EnsureSConsVersion( 2, 3, 0 )

def print_build_failures():
    from SCons.Script import GetBuildFailures
    for bf in GetBuildFailures():
        print "%s failed: %s" % (bf.node, bf.errstr)
atexit.register(print_build_failures)

def versiontuple(v):
    return tuple(map(int, (v.split("."))))

# --- OS identification ---
#
# This needs to precede the options section so that we can only offer some options on certain
# operating systems.

# This function gets the running OS as identified by Python
# It should only be used to set up defaults for options/variables, because
# its value could potentially be overridden by setting TARGET_OS on the
# command-line. Treat this output as the value of HOST_OS
def get_running_os_name():
    running_os = os.sys.platform
    if running_os.startswith('linux'):
        running_os = 'linux'
    elif running_os.startswith('freebsd'):
        running_os = 'freebsd'
    elif running_os.startswith('openbsd'):
        running_os = 'openbsd'
    elif running_os == 'sunos5':
        running_os = 'solaris'
    elif running_os == 'win32':
        running_os = 'windows'
    elif running_os == 'darwin':
        running_os = 'osx'
    else:
        running_os = 'unknown'
    return running_os

def env_get_os_name_wrapper(self):
    return env['TARGET_OS']

def is_os_raw(target_os, os_list_to_check):
    okay = False
    posix_os_list = [ 'linux', 'openbsd', 'freebsd', 'osx', 'solaris' ]

    for p in os_list_to_check:
        if p == 'posix' and target_os in posix_os_list:
            okay = True
            break
        elif p == target_os:
            okay = True
            break
    return okay

# This function tests the running OS as identified by Python
# It should only be used to set up defaults for options/variables, because
# its value could potentially be overridden by setting TARGET_OS on the
# command-line. Treat this output as the value of HOST_OS
def is_running_os(*os_list):
    return is_os_raw(get_running_os_name(), os_list)

def env_os_is_wrapper(self, *os_list):
    return is_os_raw(self['TARGET_OS'], os_list)

def add_option(name, **kwargs):

    if 'dest' not in kwargs:
        kwargs['dest'] = name

    if 'metavar' not in kwargs and kwargs.get('type', None) == 'choice':
        kwargs['metavar'] = '[' + '|'.join(kwargs['choices']) + ']'

    AddOption('--' + name, **kwargs)

def get_option(name):
    return GetOption(name)

def has_option(name):
    optval = GetOption(name)
    # Options with nargs=0 are true when their value is the empty tuple. Otherwise,
    # if the value is falsish (empty string, None, etc.), coerce to False.
    return True if optval == () else bool(optval)

def use_system_version_of_library(name):
    return has_option('use-system-all') or has_option('use-system-' + name)

# Returns true if we have been configured to use a system version of any C++ library. If you
# add a new C++ library dependency that may be shimmed out to the system, add it to the below
# list.
def using_system_version_of_cxx_libraries():
    cxx_library_names = ["tcmalloc", "boost"]
    return True in [use_system_version_of_library(x) for x in cxx_library_names]

def make_variant_dir_generator():
    memoized_variant_dir = [False]
    def generate_variant_dir(target, source, env, for_signature):
        if not memoized_variant_dir[0]:
            memoized_variant_dir[0] = env.subst('$BUILD_ROOT/$VARIANT_DIR')
        return memoized_variant_dir[0]
    return generate_variant_dir

# Options TODOs:
#
# - We should either alphabetize the entire list of options, or split them into logical groups
#   with clear boundaries, and then alphabetize the groups. There is no way in SCons though to
#   inform it of options groups.
#
# - Many of these options are currently only either present or absent. This is not good for
#   scripting the build invocation because it means you need to interpolate in the presence of
#   the whole option. It is better to make all options take an optional on/off or true/false
#   using the nargs='const' mechanism.
#

add_option('prefix',
    default='$BUILD_ROOT/install',
    help='installation prefix',
)

add_option('nostrip',
    help='do not strip installed binaries',
    nargs=0,
)

add_option('build-dir',
    default='#build',
    help='build output directory',
)

add_option('release',
    help='release build',
    nargs=0,
)

add_option('lto',
    help='enable link time optimizations (experimental, except with MSVC)',
    nargs=0,
)

add_option('dynamic-windows',
    help='dynamically link on Windows',
    nargs=0,
)

add_option('endian',
    choices=['big', 'little', 'auto'],
    default='auto',
    help='endianness of target platform',
    nargs=1,
    type='choice',
)

add_option('disable-minimum-compiler-version-enforcement',
    help='allow use of unsupported older compilers (NEVER for production builds)',
    nargs=0,
)

add_option('ssl',
    help='Enable SSL',
    nargs=0
)

add_option('mmapv1',
    choices=['auto', 'on', 'off'],
    default='auto',
    help='Enable MMapV1',
    nargs='?',
    type='choice',
)

add_option('wiredtiger',
    choices=['on', 'off'],
    const='on',
    default='on',
    help='Enable wiredtiger',
    nargs='?',
    type='choice',
)

js_engine_choices = ['mozjs', 'none']
add_option('js-engine',
    choices=js_engine_choices,
    default=js_engine_choices[0],
    help='JavaScript scripting engine implementation',
    type='choice',
)

add_option('server-js',
    choices=['on', 'off'],
    const='on',
    default='on',
    help='Build mongod without JavaScript support',
    type='choice',
)

add_option('libc++',
    help='use libc++ (experimental, requires clang)',
    nargs=0,
)

add_option('use-glibcxx-debug',
    help='Enable the glibc++ debug implementations of the C++ standard libary',
    nargs=0,
)

add_option('noshell',
    help="don't build shell",
    nargs=0,
)

add_option('safeshell',
    help="don't let shell scripts run programs (still, don't run untrusted scripts)",
    nargs=0,
)

add_option('dbg',
    choices=['on', 'off'],
    const='on',
    default='off',
    help='Enable runtime debugging checks',
    nargs='?',
    type='choice',
)

add_option('spider-monkey-dbg',
    choices=['on', 'off'],
    const='on',
    default='off',
    help='Enable SpiderMonkey debug mode',
    nargs='?',
    type='choice',
)

add_option('opt',
    choices=['on', 'off'],
    const='on',
    help='Enable compile-time optimization',
    nargs='?',
    type='choice',
)

add_option('sanitize',
    help='enable selected sanitizers',
    metavar='san1,san2,...sanN',
)

add_option('llvm-symbolizer',
    default='llvm-symbolizer',
    help='name of (or path to) the LLVM symbolizer',
)

add_option('durableDefaultOn',
    help='have durable default to on',
    nargs=0,
)

add_option('allocator',
    choices=["auto", "system", "tcmalloc"],
    default="auto",
    help='allocator to use (use "auto" for best choice for current platform)',
    type='choice',
)

add_option('gdbserver',
    help='build in gdb server support',
    nargs=0,
)

add_option('gcov',
    help='compile with flags for gcov',
    nargs=0,
)

add_option('smokedbprefix',
    help='prefix to dbpath et al. for smoke tests',
)

add_option('smokeauth',
    help='run smoke tests with --auth',
    nargs=0,
)

add_option('use-sasl-client',
    help='Support SASL authentication in the client library',
    nargs=0,
)

add_option('use-system-tcmalloc',
    help='use system version of tcmalloc library',
    nargs=0,
)

add_option('use-system-pcre',
    help='use system version of pcre library',
    nargs=0,
)

add_option('use-system-wiredtiger',
    help='use system version of wiredtiger library',
    nargs=0,
)

add_option('system-boost-lib-search-suffixes',
    help='Comma delimited sequence of boost library suffixes to search',
)

add_option('use-system-boost',
    help='use system version of boost libraries',
    nargs=0,
)

add_option('use-system-snappy',
    help='use system version of snappy library',
    nargs=0,
)

add_option('use-system-valgrind',
    help='use system version of valgrind library',
    nargs=0,
)

add_option('use-system-zlib',
    help='use system version of zlib library',
    nargs=0,
)

add_option('use-system-stemmer',
    help='use system version of stemmer',
    nargs=0)

add_option('use-system-yaml',
    help='use system version of yaml',
    nargs=0,
)

add_option('use-system-asio',
    help="use system version of ASIO",
    nargs=0,
)

add_option('use-system-icu',
    help="use system version of ICU",
    nargs=0,
)

add_option('use-system-intel_decimal128',
    help='use system version of intel decimal128',
    nargs=0,
)

add_option('use-system-all',
    help='use all system libraries',
    nargs=0,
)

add_option('use-new-tools',
    help='put new tools in the tarball',
    nargs=0,
)

add_option('build-mongoreplay',
    help='when building with --use-new-tools, build mongoreplay ( requires pcap dev )',
    nargs=1,
)

add_option('use-cpu-profiler',
    help='Link against the google-perftools profiler library',
    nargs=0,
)

add_option('build-fast-and-loose',
    choices=['on', 'off', 'auto'],
    const='on',
    default='auto',
    help='looser dependency checking',
    nargs='?',
    type='choice',
)

add_option('disable-warnings-as-errors',
    help="Don't add -Werror to compiler command line",
    nargs=0,
)

add_option('variables-help',
    help='Print the help text for SCons variables',
    nargs=0,
)

add_option('osx-version-min',
    help='minimum OS X version to support',
)

win_version_min_choices = {
    'vista'   : ('0600', '0000'),
    'win7'    : ('0601', '0000'),
    'ws08r2'  : ('0601', '0000'),
    'win8'    : ('0602', '0000'),
    'win81'   : ('0603', '0000'),
}

add_option('win-version-min',
    choices=win_version_min_choices.keys(),
    default=None,
    help='minimum Windows version to support',
    type='choice',
)

add_option('cache',
    choices=["all", "nolinked"],
    const='all',
    help='Use an object cache rather than a per-build variant directory (experimental)',
    nargs='?',
)

add_option('cache-dir',
    default='$BUILD_ROOT/scons/cache',
    help='Specify the directory to use for caching objects if --cache is in use',
)

add_option("cxx-std",
    choices=["11", "14"],
    default="11",
    help="Select the C++ langauge standard to build with",
)

def find_mongo_custom_variables():
    files = []
    for path in sys.path:
        probe = os.path.join(path, 'mongo_custom_variables.py')
        if os.path.isfile(probe):
            files.append(probe)
    return files

add_option('variables-files',
    default=find_mongo_custom_variables(),
    help="Specify variables files to load",
)

link_model_choices = ['auto', 'object', 'static', 'dynamic', 'dynamic-strict']
add_option('link-model',
    choices=link_model_choices,
    default='object',
    help='Select the linking model for the project',
    type='choice'
)

variable_parse_mode_choices=['auto', 'posix', 'other']
add_option('variable-parse-mode',
    choices=variable_parse_mode_choices,
    default=variable_parse_mode_choices[0],
    help='Select which parsing mode is used to interpret command line variables',
    type='choice',
)

add_option('modules',
    help="Comma-separated list of modules to build. Empty means none. Default is all.",
)

add_option('runtime-hardening',
    choices=["on", "off"],
    default="on",
    help="Enable runtime hardening features (e.g. stack smash protection)",
    type='choice',
)

add_option('use-s390x-crc32',
    choices=["on", "off"],
    default="on",

=== src/third_party/wiredtiger/SConstruct ===
# -*- mode: python; -*-
import re
import os
import shutil
import subprocess
import sys
import tempfile
import textwrap
import distutils.sysconfig

EnsureSConsVersion( 2, 0, 0 )

if not os.sys.platform == "win32":
    print ("SConstruct is only supported for Windows, use build_posix for other platforms")
    Exit(1)

# Command line options
#
AddOption("--dynamic-crt", dest="dynamic-crt", action="store_true", default=False,
          help="Link with the MSVCRT DLL version")

AddOption("--enable-attach", dest="attach", action="store_true", default=False,
          help="Configure for debugger attach on failure.")

AddOption("--enable-diagnostic", dest="diagnostic", action="store_true", default=False,
          help="Configure WiredTiger to perform various run-time diagnostic tests. DO NOT configure this option in production environments.")

AddOption("--enable-lz4", dest="lz4", type="string", nargs=1, action="store",
          help="Use LZ4 compression")

AddOption("--enable-python", dest="lang-python", type="string", nargs=1, action="store",
          help="Build Python extension, specify location of swig.exe binary")

AddOption("--enable-snappy", dest="snappy", type="string", nargs=1, action="store",
          help="Use snappy compression")

AddOption("--enable-tcmalloc", dest="tcmalloc", type="string", nargs=1, action="store",
          help="Use TCMalloc for memory allocation")

AddOption("--enable-verbose", dest="verbose", action="store_true", default=False,
          help="Configure WiredTiger to support the verbose configuration string to wiredtiger_open")

AddOption("--enable-zlib", dest="zlib", type="string", nargs=1, action="store",
          help="Use zlib compression")

AddOption("--prefix", dest="prefix", type="string", nargs=1, action="store", default="package",
          help="Install directory")

AddOption("--with-berkeley-db", dest="bdb", type="string", nargs=1, action="store",
          help="Berkeley DB install path, ie, /usr/local")

# Get the swig binary from the command line option since SCONS cannot find it automatically
#
swig_binary = GetOption("lang-python")

# Initialize environment
#
var = Variables()

var.Add('MSVC_USE_SCRIPT', 'Path to vcvars.bat to override SCons default VS tool search');

var.Add('CPPPATH', 'C Preprocessor include path', [
    "#/src/include/",
    "#/build_win",
    "#/test/windows",
    "#/.",
])

var.Add('CFLAGS', 'C Compiler Flags', [
    "/Z7", # Generate debugging symbols
    "/wd4090", # Ignore warning about mismatched const qualifiers
    "/wd4996", # Ignore deprecated functions
    "/W3", # Warning level 3
    #"/we4244", # Possible loss of data
    "/we4013", # Error on undefined functions
    #"/we4047", # Indirection differences in types
    #"/we4024", # Differences in parameter types
    #"/we4100", # Unreferenced local parameter
    "/TC", # Compile as C code
    #"/Od", # Disable optimization
    "/Ob1", # inline expansion
    "/O2", # optimize for speed
    "/GF", # enable string pooling
    "/EHsc", # extern "C" does not throw
    #"/RTC1", # enable stack checks
    "/GS", # enable security checks
    "/Gy", # separate functions for linker
    "/Zc:wchar_t",
    "/Gd",
    "/MD" if GetOption("dynamic-crt") else "/MT",
])

var.Add('LINKFLAGS', 'Linker Flags', [
    "/DEBUG", # Generate debug symbols
    "/INCREMENTAL:NO", # Disable incremental linking
    "/OPT:REF", # Remove dead code
    "/DYNAMICBASE",
    "/NXCOMPAT",
])

var.Add('TOOLS', 'SCons tools', [
    "default",
    "swig",
    "textfile"
])

var.Add('SWIG', 'SWIG binary location', swig_binary)

env = Environment(
    variables = var
)

env['STATIC_AND_SHARED_OBJECTS_ARE_THE_SAME'] = 1

useZlib = GetOption("zlib")
useSnappy = GetOption("snappy")
useLz4 = GetOption("lz4")
useBdb = GetOption("bdb")
useTcmalloc = GetOption("tcmalloc")
wtlibs = []

conf = Configure(env)
if not conf.CheckCHeader('stdlib.h'):
    print 'stdlib.h must be installed!'
    Exit(1)

if useZlib:
    conf.env.Append(CPPPATH=[useZlib + "/include"])
    conf.env.Append(LIBPATH=[useZlib + "/lib"])
    if conf.CheckCHeader('zlib.h'):
        conf.env.Append(CPPDEFINES=["HAVE_BUILTIN_EXTENSION_ZLIB"])
        wtlibs.append("zlib")
    else:
        print 'zlib.h must be installed!'
        Exit(1)

if useSnappy:
    conf.env.Append(CPPPATH=[useSnappy + "/include"])
    conf.env.Append(LIBPATH=[useSnappy + "/lib"])
    if conf.CheckCHeader('snappy-c.h'):
        conf.env.Append(CPPDEFINES=['HAVE_BUILTIN_EXTENSION_SNAPPY'])
        wtlibs.append("snappy")
    else:
        print 'snappy-c.h must be installed!'
        Exit(1)

if useLz4:
    conf.env.Append(CPPPATH=[useLz4 + "/include"])
    conf.env.Append(LIBPATH=[useLz4 + "/lib"])
    if conf.CheckCHeader('lz4.h'):
        conf.env.Append(CPPDEFINES=['HAVE_BUILTIN_EXTENSION_LZ4'])
        wtlibs.append("lz4")
    else:
        print 'lz4.h must be installed!'
        Exit(1)

if useBdb:
    conf.env.Append(CPPPATH=[useBdb+ "/include"])
    conf.env.Append(LIBPATH=[useBdb+ "/lib"])
    if not conf.CheckCHeader('db.h'):
        print 'db.h must be installed!'
        Exit(1)

if useTcmalloc:
    conf.env.Append(CPPPATH=[useTcmalloc + "/include"])
    conf.env.Append(LIBPATH=[useTcmalloc + "/lib"])
    if conf.CheckCHeader('gperftools/tcmalloc.h'):
        wtlibs.append("libtcmalloc_minimal")
        conf.env.Append(CPPDEFINES=['HAVE_LIBTCMALLOC'])
        conf.env.Append(CPPDEFINES=['HAVE_POSIX_MEMALIGN'])
    else:
        print 'tcmalloc.h must be installed!'
        Exit(1)

env = conf.Finish()

# Configure build environment variables
#
if GetOption("attach"):
    env.Append(CPPDEFINES = ["HAVE_ATTACH"])

if GetOption("diagnostic"):
    env.Append(CPPDEFINES = ["HAVE_DIAGNOSTIC"])

if GetOption("lang-python"):
    env.Append(LIBPATH=[distutils.sysconfig.PREFIX + r"\libs"])
    env.Append(CPPPATH=[distutils.sysconfig.get_python_inc()])

if GetOption("verbose"):
    env.Append(CPPDEFINES = ["HAVE_VERBOSE"])


# Build WiredTiger.h file
#
version_file = 'build_posix/aclocal/version-set.m4'

VERSION_MAJOR = None
VERSION_MINOR = None
VERSION_PATCH = None
VERSION_STRING = None

# Read the version information from the version-set.m4 file
for l in open(File(version_file).srcnode().abspath):
    if re.match(r'^VERSION_[A-Z]+', l):
        exec(l)

if (VERSION_MAJOR == None or
    VERSION_MINOR == None or
    VERSION_PATCH == None or
    VERSION_STRING == None):
    print "Failed to find version variables in " + version_file
    Exit(1)

wiredtiger_includes = """
        #include <sys/types.h>
        #include <stdarg.h>
        #include <stdbool.h>
        #include <stdint.h>
        #include <stdio.h>
    """
wiredtiger_includes = textwrap.dedent(wiredtiger_includes)
replacements = {
    '@VERSION_MAJOR@' : VERSION_MAJOR,
    '@VERSION_MINOR@' : VERSION_MINOR,
    '@VERSION_PATCH@' : VERSION_PATCH,
    '@VERSION_STRING@' : VERSION_STRING,
    '@uintmax_t_decl@': "",
    '@uintptr_t_decl@': "",
    '@off_t_decl@' : 'typedef int64_t wt_off_t;',
    '@wiredtiger_includes_decl@': wiredtiger_includes
}

wtheader = env.Substfile(
    target='wiredtiger.h',
    source=[
        'src/include/wiredtiger.in',
    ],
    SUBST_DICT=replacements)

#
# WiredTiger library
#
# Map WiredTiger build conditions: any conditions that appear in WiredTiger's
# dist/filelist must appear here, and if the value is true, those files will be
# included.
#
condition_map = {
    'ARM64_HOST' : False,
    'POSIX_HOST' : env['PLATFORM'] == 'posix',
    'POWERPC_HOST' : False,
    'WINDOWS_HOST' : env['PLATFORM'] == 'win32',
    'X86_HOST' : True,
    'ZSERIES_HOST' : False,
}

def filtered_filelist(f):
    for line in f:
        file_cond = line.split()
        if line.startswith("#") or len(file_cond) == 0:
            continue
        if len(file_cond) == 1 or condition_map[file_cond[1]]:
            yield file_cond[0]

filelistfile = r'dist/filelist'
wtsources = list(filtered_filelist(open(filelistfile)))

if useZlib:
    wtsources.append("ext/compressors/zlib/zlib_compress.c")

if useSnappy:
    wtsources.append("ext/compressors/snappy/snappy_compress.c")

if useLz4:
    wtsources.append("ext/compressors/lz4/lz4_compress.c")

wt_objs = [env.Object(a) for a in wtsources]

# Static Library - libwiredtiger.lib
#
wtlib = env.Library(
    target="libwiredtiger",
    source=wt_objs, LIBS=wtlibs)

env.Depends(wtlib, [filelistfile, version_file])

# Dynamically Loaded Library - wiredtiger.dll
#
wtdll = env.SharedLibrary(
    target="wiredtiger",
    source=wt_objs + ['build_win/wiredtiger.def'], LIBS=wtlibs)

env.Depends(wtdll, [filelistfile, version_file])

Default(wtlib, wtdll)

wtbin = env.Program("wt", [
    "src/utilities/util_alter.c",
    "src/utilities/util_backup.c",
    "src/utilities/util_cpyright.c",
    "src/utilities/util_compact.c",
    "src/utilities/util_create.c",
    "src/utilities/util_drop.c",
    "src/utilities/util_dump.c",
    "src/utilities/util_list.c",
    "src/utilities/util_load.c",
    "src/utilities/util_load_json.c",
    "src/utilities/util_loadtext.c",
    "src/utilities/util_main.c",
    "src/utilities/util_misc.c",
    "src/utilities/util_printlog.c",
    "src/utilities/util_read.c",
    "src/utilities/util_rebalance.c",
    "src/utilities/util_rename.c",
    "src/utilities/util_salvage.c",
    "src/utilities/util_stat.c",
    "src/utilities/util_truncate.c",
    "src/utilities/util_upgrade.c",
    "src/utilities/util_verbose.c",
    "src/utilities/util_verify.c",
    "src/utilities/util_write.c"],
    LIBS=[wtlib] + wtlibs)

Default(wtbin)

# Python SWIG wrapper for WiredTiger
if GetOption("lang-python"):
    # Check that this version of python is 64-bit
    #
    if sys.maxsize < 2**32:
        print "The Python Interpreter must be 64-bit in order to build the python bindings"
        Exit(1)

    pythonEnv = env.Clone()
    pythonEnv.Append(SWIGFLAGS=[
            "-python",
            "-threads",
            "-O",
            "-nodefaultctor",
            "-nodefaultdtor",
            ])

    swiglib = pythonEnv.SharedLibrary('_wiredtiger',
                      [ 'lang\python\wiredtiger.i'],
                      SHLIBSUFFIX=".pyd",
                      LIBS=[wtlib] + wtlibs)

    copySwig = pythonEnv.Command(
        'lang/python/wiredtiger/__init__.py',
        'lang/python/wiredtiger.py',
        Copy('$TARGET', '$SOURCE'))
    pythonEnv.Depends(copySwig, swiglib)

    swiginstall = pythonEnv.Install('lang/python/wiredtiger/', swiglib)

    Default(swiginstall, copySwig)

# Shim library of functions to emulate POSIX on Windows
shim = env.Library("window_shim",
        ["test/windows/windows_shim.c"])



examples = [
    "ex_access",
    "ex_all",
    "ex_async",
    "ex_call_center",
    "ex_config_parse",
    "ex_cursor",
    "ex_data_source",
    "ex_encrypt",
    "ex_extending",
    "ex_file_system",
    "ex_hello",
    "ex_log",
    "ex_pack",
    "ex_process",
    "ex_schema",
    "ex_stat",
    "ex_thread",
    ]

# WiredTiger Smoke Test support
# Runs each test in a custom temporary directory
def run_smoke_test(x):
    print "Running Smoke Test: " + x

    # Make temp dir
    temp_dir = tempfile.mkdtemp(prefix="wt_home")

    try:
        # Set WT_HOME environment variable for test
        os.environ["WIREDTIGER_HOME"] = temp_dir

        # Run the test
        ret = subprocess.call(x);
        if( ret != 0):
            sys.stderr.write("Bad exit code %d\n" % (ret))
            raise Exception()

    finally:
        # Clean directory
        #
        shutil.rmtree(temp_dir)

def builder_smoke_test(target, source, env):
    run_smoke_test(source[0].abspath)
    return None

env.Append(BUILDERS={'SmokeTest' : Builder(action = builder_smoke_test)})

#Build the tests and setup the "scons test" target

testutil = env.Library('testutil',
            [
                'test/utility/misc.c',
                'test/utility/parse_opts.c'
            ])

#Don't test bloom on Windows, its broken
t = env.Program("t_bloom",

=== debian/changelog ===
mongodb (1:3.4.18-2) unstable; urgency=medium

  * Strip test binaries to reduce build disk usage, fixing FTBFS on most
    architectures. Patch by Dimitri John Ledkov, imported from Ubuntu.

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Tue, 04 Dec 2018 11:07:25 +0200

mongodb (1:3.4.18-1) unstable; urgency=medium

  * New upstream stable bugfix release
  * Drop fix-altivec-endianness.patch; merged upstream
  * Bump Standards-Version to 4.2.1; no changes needed
  * Do not pass -Werror; fix FTBFS with GCC 8 (and hopefully future versions)
    (Closes: #897812)
  * Fix FTBFS with OpenSSL 1.1.1 (introduced in 3.4.17)
  * Fix FTBFS with Boost 1.66

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Mon, 03 Dec 2018 20:56:36 +0200

mongodb (1:3.4.15-1) unstable; urgency=medium

  * New upstream stable bugfix release
  * Bump Standards-Version to 4.1.4; no changes needed
  * Change maintainer address to tracker.d.o (Closes: #899815)

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Wed, 20 Jun 2018 14:12:10 +0300

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: mongodb
 Section: database
 Priority: optional
-Maintainer: Debian MongoDB Maintainers <pkg-mongodb-maintainers@lists.alioth.debian.org>
+Maintainer: Debian MongoDB Maintainers <team+mongodb@tracker.debian.org>
 Uploaders: Laszlo Boszormenyi (GCS) <gcs@debian.org>,
            Jérémy Lal <kapouer@melix.org>,
            Apollon Oikonomopoulos <apoikos@debian.org>
@@ -30,7 +30,7 @@
  scons,
  tzdata,
  valgrind
-Standards-Version: 4.1.3
+Standards-Version: 4.2.1
 Vcs-Git: https://salsa.debian.org/mongodb-team/mongodb.git
 Vcs-Browser: https://salsa.debian.org/mongodb-team/mongodb
 Homepage: https://www.mongodb.org
@@ -88,9 +88,9 @@
 Architecture: amd64 arm64 ppc64el s390x
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Breaks:
- mongodb-server (<< 1:3.4.7-1ubuntu2)
+ mongodb-server (<< 1:3.4.14-1~)
 Replaces:
- mongodb-server (<< 1:3.4.7-1ubuntu2)
+ mongodb-server (<< 1:3.4.14-1~)
 Description: object/document-oriented database (server binaries package)
  MongoDB is a high-performance, open source, schema-free
  document-oriented data store that's easy to deploy, manage

=== debian/rules ===
--- 
+++ 
@@ -26,6 +26,7 @@
 		 --use-system-boost --use-system-snappy \
 		 --use-system-zlib --use-system-valgrind \
 		 --use-system-stemmer --use-system-yaml \
+		 --disable-warnings-as-errors \
 		 --ssl $(DEB_SCONS_OPTIONS) \
 		 CC=$(CC) CXX=$(CXX)
 
@@ -61,19 +62,18 @@
 override_dh_auto_install:
 	scons $(COMMON_OPTIONS) --prefix=$(CURDIR)/debian/tmp/usr install
 
-override_dh_systemd_enable:
-	dh_systemd_enable -pmongodb-server --name=mongodb
+override_dh_installsystemd:
+	dh_installsystemd -pmongodb-server --name=mongodb
 
 override_dh_installinit:
 	dh_installinit -pmongodb-server --name=mongodb
 
-
-override_dh_install:
-	dh_install --list-missing
+override_dh_missing:
+	dh_missing --list-missing
 
 %:
-	dh $@ --parallel
+	dh $@
 
 .PHONY: override_dh_auto_clean override_dh_auto_build \
 	override_dh_auto_install override_dh_installinit \
-	override_dh_systemd_enable override_dh_install
+	override_dh_installsystemd override_dh_missing
